#ifndef _MESH_H_
#define _MESH_H_

#include <vector>
#include "glm/glm.hpp"
#include "glm/gtc/type_ptr.hpp"
#include "glm/gtc/matrix_transform.hpp"
#include "vec.h"

typedef glm::vec4 Point;
typedef glm::vec3 Normal;

class Mesh {
public :
	std::vector<Point> points;
	std::vector<Normal> normals;
	std::vector<std::vector<unsigned int>> faces; // faces[i] = list of vertex indices of face i
	std::vector<unsigned int> triangles; // list of vertex indices : triangles[3*i] triangles[3*i+1] triangles[3*i+2] define a face

	Point color;

	int nbEdges;
	
public :
	Mesh() {
		color = Point(0,1,0,1);
	}

	~Mesh() {
		points.clear();
		normals.clear();
		faces.clear();
		triangles.clear();
	}

	void setColor(Point col) { color = col; };
	void draw();
	void updateMesh(std::vector<Vec> positions);

};

#endif